import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class ListBuy extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out=response.getWriter();

			String userid=CookieUser.getUser(request);

			if(userid==null)
				response.sendRedirect(JoeEnv.LoginLocation);

			String useridQuery="";

			if(userid!=null&&userid.length()!=0)
				useridQuery=" AND joe_buy.id="+"'"+userid+"'";
			String queryString="";
			if(JoeEnv.admin.equals(userid))
				queryString="SELECT id, joe_game.name, joe_game.gameid FROM joe_game, joe_buy WHERE joe_game.gameid = joe_buy.gameid";
			else
				queryString="SELECT id, joe_game.name, joe_game.gameid FROM joe_game, joe_buy WHERE joe_game.gameid = joe_buy.gameid"+useridQuery;

			out.println("<!--");
			out.println(queryString);
			out.println("-->");

			out.println("<HTML>");
			out.println("<HEAD>");
			out.println("<TITLE>");
			out.println("Buy List");
			out.println("</TITLE>");
			out.println("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\""+JoeEnv.styleDir+"/labstyle.css\" TITLE=\"Style\"");
			out.println("</HEAD>");
			out.println("<BODY bgcolor=\"#ffffff\">");
			out.println("<CENTER><A HREF=\"ListBuy\"><IMG SRC=\"");
			out.println(JoeEnv.imgDir+"/project/banner_buylist.gif\" border=0></A>");
			out.println("<P>");
	
			out.println("<TABLE BORDER=5>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("ID");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Game name");
			out.println("</TH>");

			out.println("</TR>");

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				String user=(String)resultEntryVector.elementAt(0);
				String gamename=(String)resultEntryVector.elementAt(1);
				String gameid=(String)resultEntryVector.elementAt(2);
				out.println("<TR>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListUser?userid="+user);
				out.println("\">");
				out.println(user);
				out.println("</A>");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?gameid="+gameid);
				out.println("\">");
				out.println(gamename);
				out.println("</A>");
				out.println("</TD>");

				out.println("</TR>");
			}
			
			out.println("</CENTER></TABLE>");
			out.println("</BODY>");
			out.println("</HTML>");
			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
