import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class ListStaff extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out = response.getWriter();

			if(CookieUser.getUser(request)==null)
				response.sendRedirect(JoeEnv.LoginLocation);

			String qgameid=request.getParameter("gameid");
			String qstaffid=request.getParameter("staffid");

			String gameidQuery="";
			String staffidQuery="";

			if(qgameid!=null&&qgameid.length()!=0)
				gameidQuery=" AND joe_staff.gameid="+qgameid;
			if(qstaffid!=null&&qstaffid.length()!=0)
				staffidQuery=" AND joe_staff.staffid="+qstaffid;

			String queryString="SELECT joe_staff.staffid, joe_staff.gameid, joe_game.name, joe_staff.name, joe_staff.email, dowhat FROM joe_game, joe_staff WHERE joe_staff.gameid = joe_game.gameid"+gameidQuery+staffidQuery;

			out.println("<!--");
			out.println(queryString);
			out.println("-->");

			out.println("<HTML>");
			out.println("<HEAD>");
			out.println("<TITLE>");
			out.println("Staff");
			out.println("</TITLE>");
			out.println("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\""+JoeEnv.styleDir+"/labstyle.css\" TITLE=\"Style\"");
			out.println("</HEAD>");
			out.println("<BODY bgcolor=\"#ffffff\">");
			out.println("<CENTER><A HREF=\"ListStaff\"><IMG SRC=\"");
			out.println(JoeEnv.imgDir+"/project/banner_staff.gif\" border=0></A>");
			out.println("<P>");
			out.println("<TABLE BORDER=5>");

			out.println("<TH ALIGN=RIGHT>");
			out.println("Game Name");
			out.println("</TH>");

			out.println("<TH ALIGN=RIGHT>");
			out.println("Staff Name");
			out.println("</TH>");

			out.println("<TH ALIGN=RIGHT>");
			out.println("Email");
			out.println("</TH>");

			out.println("<TH ALIGN=RIGHT>");
			out.println("Do what");
			out.println("</TH>");

			if(JoeEnv.admin.equals(CookieUser.getUser(request)))
			{
				out.println("<TH NOWRAP ALIGN=RIGHT>");
				out.println("Update");
				out.println("</TH>");

				out.println("<TH NOWRAP ALIGN=RIGHT>");
				out.println("Delete");
				out.println("</TH>");
			}

			out.println("</TR>");

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				String staffid=(String)resultEntryVector.elementAt(0);
				String gameid=(String)resultEntryVector.elementAt(1);
				String gamename=(String)resultEntryVector.elementAt(2);
				String staffname=(String)resultEntryVector.elementAt(3);
				String email=(String)resultEntryVector.elementAt(4);
				String dowhat=(String)resultEntryVector.elementAt(5);

				out.println("<TR>");

				out.println("<TD ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?gameid="+gameid);
				out.println("\">");
				out.println(gamename);
				out.println("</TD>");

				out.println("<TD ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("mailto:"+email);
				out.println("\">");
				out.println(staffname);
				out.println("</A>");
				out.println("</TD>");

				out.println("<TD ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("mailto:"+email);
				out.println("\">");
				out.println(email);
				out.println("</A>");
				out.println("</TD>");

				out.println("<TD ALIGN=RIGHT>");
				out.println(dowhat);
				out.println("</TD>");

				if(JoeEnv.admin.equals(CookieUser.getUser(request)))
				{
					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<A HREF=\"");
					out.println("UpdateStaff?staffid="+staffid);
					out.println("\">");
					out.println("Update Staff");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<A HREF=\"");
					out.println("DeleteStaff?staffid="+staffid);
					out.println("\">");
					out.println("Delete Staff");
					out.println("</TD>");
				}

				out.println("</TR>");
			}

			if(JoeEnv.admin.equals(CookieUser.getUser(request)))
			{
				out.println("<TR>");
				out.println("<FORM METHOD=\"POST\" ACTION=\"InsertStaff\">");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<SELECT NAME=\"gameid\">");
				queryString="SELECT name, gameid from joe_game";
				result=dbQuery.query(queryString);
				resultIterator=result.iterator();
				String entry1;
				String entry2;
				while(resultIterator.hasNext())
				{
					resultEntryVector=(Vector)resultIterator.next();
					entry1=(String)resultEntryVector.elementAt(0);
					entry2=(String)resultEntryVector.elementAt(1);
					if(entry2.trim().equals(qgameid))
						out.println("<OPTION VALUE=\""+entry2+"\" SELECTED>"+entry1);
					else
						out.println("<OPTION VALUE=\""+entry2+"\">"+entry1);
				}
				out.println("</SELECT>");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"staffname\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"email\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"dowhat\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"insert\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"RESET\" VALUE=\"reset\">");
				out.println("</TD>");

				out.println("</FORM>");

				out.println("</TR>");
			}

			out.println("</CENTER></TABLE>");
			out.println("</BODY>");
			out.println("</HTML>");
			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
