import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class UpdateStaff extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out=response.getWriter();

			String qstaffid=request.getParameter("staffid");

			String staffidQuery="";

			if(qstaffid!=null&&qstaffid.length()!=0)
				staffidQuery=" AND joe_staff.staffid="+qstaffid;

			String queryString="SELECT staffid, gameid, name, email, dowhat FROM joe_staff WHERE joe_staff.staffid = joe_staff.staffid"+staffidQuery;

			out.println("<!--");
			out.println(queryString);
			out.println("-->");

			out.println("<HTML>");
			out.println("<HEAD>");
			out.println("<TITLE>");
			out.println("Staff");
			out.println("</TITLE>");
			out.println("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\""+JoeEnv.styleDir+"/labstyle.css\" TITLE=\"Style\"");
			out.println("</HEAD>");
			out.println("<BODY bgcolor=\"#ffffff\">");
			out.println("<CENTER><A HREF=\"ListStaff\"><IMG SRC=\"");
			out.println(JoeEnv.imgDir+"/project/banner_staff.gif\" border=0></A></CENTER>");
			out.println("<P>");
			out.println("<TABLE BORDER=5>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Game Name");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Staff Name");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Email");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Do what");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("</TH>");

			out.println("</TR>");

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				String staffid=((String)resultEntryVector.elementAt(0)).trim();
				String gameid=((String)resultEntryVector.elementAt(1)).trim();
				String staffname=((String)resultEntryVector.elementAt(2)).trim();
				String email=((String)resultEntryVector.elementAt(3)).trim();
				String dowhat=((String)resultEntryVector.elementAt(4)).trim();

				if(JoeEnv.admin.equals(CookieUser.getUser(request)))
				{
					out.println("<TR>");

					out.println("<FORM METHOD=\"POST\" ACTION=\"ExecuteUpdateStaff\">");
					out.println("<INPUT TYPE=\"HIDDEN\"");
					out.println("NAME=\"staffid\"");
					out.println("VALUE=\"");
					out.println(staffid);
					out.println("\">");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<SELECT NAME=\"gameid\">");
					queryString="SELECT name, gameid from joe_game";
					result=dbQuery.query(queryString);
					resultIterator=result.iterator();
					String entry1;
					String entry2;
					while(resultIterator.hasNext())
					{
						resultEntryVector=(Vector)resultIterator.next();
						entry1=(String)resultEntryVector.elementAt(0);
						entry2=(String)resultEntryVector.elementAt(1);
						if(gameid.equals(entry2.trim()))
							out.println("<OPTION VALUE=\""+entry2+"\" SELECTED>"+entry1);
						else
							out.println("<OPTION VALUE=\""+entry2+"\">"+entry1);
					}
					out.println("</SELECT>");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"TEXT\"");
					out.println("NAME=\"staffname\"");
					out.println("VALUE=\"");
					out.println(staffname);
					out.println("\">");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"TEXT\"");
					out.println("NAME=\"email\"");
					out.println("VALUE=\"");
					out.println(email);
					out.println("\">");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"TEXT\"");
					out.println("NAME=\"dowhat\"");
					out.println("VALUE=\"");
					out.println(dowhat);
					out.println("\">");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"SUBMIT\"");
					out.println("VALUE=\"Update\">");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"RESET\"");
					out.println("VALUE=\"reset\">");
					out.println("</TD>");

					out.println("</FORM>");
					out.println("</TR>");
				}
			}
			
			out.println("</TABLE>");
			out.println("</BODY>");
			out.println("</HTML>");
			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
