import java.lang.*;
import java.net.URL;
import java.sql.*;
import com.imaginary.sql.msql.*;
import KnowledgeBase;
import Attributes;

class AttributesManager {

	KnowledgeBase KB;
	Attributes Conclusion ;
	Attributes ModifyQuery;

	public AttributesManager()
	{
		Conclusion = new Attributes();
		ModifyQuery = new Attributes();
		KB = new KnowledgeBase();
	}

	public AttributesManager(Attributes query)
	{
		Conclusion = new Attributes();
		ModifyQuery = new Attributes();
		ModifyQuery = query;
		KB = new KnowledgeBase();
	}

				                 
     public Attributes Forward_Chaining(Attributes query) 
     {
     	     int Onecheck = 0;

         	 boolean Match= false;

		 try {
		   while(KB.premise.next()&& Match == false ) 
		   {
			String Tag = new String();

			//copying the premiseTag the Tag
			Tag =KB.premise.getString("Tag");
			


			for(int i = 0;i < Tag.length() ; i++)
  		        {

				if(Tag.charAt(i) == query.Tag.charAt(i))
					Match = true; 

				if(Tag.charAt(i) == '1' && 
					Tag.charAt(i) == query.Tag.charAt(i))
				{
				           Match = Unify(i, query);
				}

				else if(Tag.charAt(i) != query.Tag.charAt(i))
					       Match = false;

				if(Match == false)
					break;
				else
				  continue;
			}


			if(Match == true)
			{
			   
			   Conclusion = 
			       findConclusion(query, KB.premise.getInt("ID"));

			  if(Conclusion != null)
			  	Onecheck = 1;
			  else
			  	Onecheck = 0;
			}

		}  //end of While

		}   //end of Try

		catch( Exception e ) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}


		return Conclusion;		
       }


 // attribute value comparison with query 
       public boolean Unify(int i, Attributes query)
       {
	   String str= new String();;

	   
	try {
	   switch(i)
	   {
		     case (0):
			str = KB.premise.getString("Date");
			if( str.compareTo(query.Date)== 0 )
			{
				return true;
			}
			break;
		     case (1):
			str = KB.premise.getString("Label");
			if( str.compareTo(query.Label)==0)
				return true;
			break;
		     case (2):
			str = KB.premise.getString("Title");
			if( str.compareTo(query.Title)== 0)
				return true;
			break;

		     case (3):
			str = KB.premise.getString("Artist");
			if( str.compareTo( query.Artist)==0)
				return true;
			break;
		     case (4):
			if( KB.premise.getInt("More") <= query.More)
				return true;
			break;
		     case (5):
			if( KB.premise.getInt("Less")>= query.Less)
				return true;
			break;
		     case (6):
			if( KB.premise.getInt("Expensive")== query.Expensive)
				return true;
			break;
		     case (7):
			if( KB.premise.getInt("Cheap")== query.Cheap)
				return true;
			break;

		     case (8):
			if( KB.premise.getInt("SalesRating")==query.SalesRating)
				return true;
			break;
		     case (9):
			if( KB.premise.getInt("CriticsRating")==query.CriticsRating)
				return true;
			break;
		     case (10):
			if( KB.premise.getInt("Good")== query.Good)
				return true;
			break;
		     case (11):
			if( KB.premise.getInt("Bad")== query.Bad)
				return true;
			break;
		     default:
				return  false;
		}
	  }
		catch( Exception e ) {
			System.out.println(e.getMessage());
			e.printStackTrace();
		}

		return false ; 
       }


      public  Attributes findConclusion(Attributes query,int id)
      {
          int Check = 0;
	  try {
	      while(KB.conclusion.next()&&(Check == 0 ))
	 	{
		 if(KB.conclusion.getInt("ID") == id)
		   {
			String temp = new String();
			temp =KB.conclusion.getString("Tag");
			Check = 1;

			for( int p = 0; p <12 ; p++)
			{
			 	if( temp.charAt(p) == '1')
					query = GetConclusion(query,p);
				
			}
		    }
		}
	    }
	    catch( Exception e ) {
		System.out.println(e.getMessage());
		e.printStackTrace();
            }

	  return query;

	}

					


       private Attributes GetConclusion(Attributes query, int id)
       {

	       Attributes Imsi_Result = new Attributes();

	    try {
	        switch(id)
	        {
		     case (0):
			      ModifyQuery.Date = KB.conclusion.getString("Date");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 0);
			      Imsi_Result.Tag = "100000000000";
			      Imsi_Result.Date =ModifyQuery.Date; 
			      Imsi_Result = Forward_Chaining(Imsi_Result);	
			      return Imsi_Result;
		     case (1):
			      ModifyQuery.Label = KB.conclusion.getString("Label");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 1);
			      Imsi_Result.Tag = "010000000000";
			      Imsi_Result.Label = ModifyQuery.Label;
			      Imsi_Result = Forward_Chaining(Imsi_Result);	
			      return Imsi_Result;
		    case (2):
			      ModifyQuery.Title = KB.conclusion.getString("Title");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 2);
			      Imsi_Result.Tag = "001000000000";
			      Imsi_Result.Title = ModifyQuery.Title;
		              Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (3):
			      ModifyQuery.Artist = KB.conclusion.getString("Artist");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 3);
			      Imsi_Result.Tag = "000100000000";
			      Imsi_Result.Artist = ModifyQuery.Artist;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (4):
			      ModifyQuery.More = KB.conclusion.getInt("More");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 4);
			      Imsi_Result.Tag = "000010000000";
			      Imsi_Result.More = ModifyQuery.More;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (5):
			      ModifyQuery.Less = KB.conclusion.getInt("Less");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 5);
			      Imsi_Result.Tag = "000001000000";
			      Imsi_Result.Less = ModifyQuery.Less;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (6):
			      ModifyQuery.Expensive = KB.conclusion.getInt("Expensive");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 6);
			      Imsi_Result.Tag = "000000100000";
			      Imsi_Result.Expensive = ModifyQuery.Expensive;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (7):
			      ModifyQuery.Cheap = KB.conclusion.getInt("Cheap");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 7);
			      Imsi_Result.Tag = "000000010000";
			      Imsi_Result.Cheap = ModifyQuery.Cheap;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (8):
			      ModifyQuery.SalesRating = KB.conclusion.getInt("SalesRating");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 8);
			      Imsi_Result.Tag = "000000001000";
			      Imsi_Result.SalesRating = ModifyQuery.SalesRating;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (9):
			      ModifyQuery.CriticsRating = KB.conclusion.getInt("CriticsRating");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 9);
			      Imsi_Result.Tag = "000000000100";
			      Imsi_Result.CriticsRating = ModifyQuery.CriticsRating;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (10):
			      ModifyQuery.Good = KB.conclusion.getInt("Good");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 10);
			      Imsi_Result.Tag = "000000000010";
			      Imsi_Result.Good = ModifyQuery.Good;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     case (11):
			      ModifyQuery.Bad = KB.conclusion.getInt("Bad");
			      ModifyQuery.Tag = ModifyTag(ModifyQuery.Tag, 11);
			      Imsi_Result.Tag = "000000000001";
			      Imsi_Result.Bad = ModifyQuery.Bad;
			      Imsi_Result = Forward_Chaining(Imsi_Result);
			      return Imsi_Result;
		     default:
				return null;
	       }
	  }

	    catch( Exception e ) {
		System.out.println(e.getMessage());
		e.printStackTrace();
               }
	    return null;
     }

      public void PrintAttri(Attributes Result)
        {
                System.out.println(Result.Date);
                System.out.println(Result.Label);
                System.out.println(Result.Title);
                System.out.println(Result.Artist);
                System.out.println(Result.More);
                System.out.println(Result.Less);
                System.out.println(Result.Expensive);
                System.out.println(Result.Cheap);
                System.out.println(Result.SalesRating);
                System.out.println(Result.CriticsRating);
                System.out.println(Result.Good);
                System.out.println(Result.Bad);


        }

	public String ModifyTag(String Str, int i)
	{
	      StringBuffer I = new StringBuffer(Str);
	      I.setCharAt(i, '1');
	      Str = I.toString();
	      return Str;

 	}

}
