import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import jess.*;


public class Jess extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out=response.getWriter();

			String id="";
			String age="";
			String job="";
			String hobby="";
			String character="";
			String queryString;

			id=CookieUser.getUser(request);

			if(id==null)
				response.sendRedirect(JoeEnv.LoginLocation);

			queryString="SELECT age, job, hobby, character FROM joec_user WHERE id = '"+id+"'";

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				age=((String)resultEntryVector.elementAt(0)).trim();
				job=((String)resultEntryVector.elementAt(1)).trim();
				hobby=((String)resultEntryVector.elementAt(2)).trim();
				character=((String)resultEntryVector.elementAt(3)).trim();
			}

			new Recommender(age, job, hobby, character);

			String priceob="";

			if(Attr.Price.equals("10"))
				priceob="%3C";
			else
				priceob="%3E";

			response.sendRedirect("ListGame?price="+Attr.Price+"&priceob="+priceob+"&genre="+Attr.Genre);

			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
