
/* Ʈ Է ޾Ƽ
getNext θ  Ʈ ϳ ش.
Ʈ: tagǴ string
*/

/* input: html document
	output: tokenized components
*/

import java.io.*;
import java.lang.*;
import java.net.*;

public class Tokenize {

	public static final int invalid_type = -1;
	public static final int tag_type = 0;
	public static final int text_type = 1;

	String input ;
	int token_type = invalid_type;
	int index = 0;


	Tokenize( URL url ){
	//download a file from url and tokenize it

		RemoteDocument d = new RemoteDocument( url );
		input = d.getDocString();
	}	

	Tokenize( String s){
	//tokenize String s
		input = s;
	}

	Tokenize( FileInputStream file ){
	//local file

		StringBuffer tmp =  new StringBuffer();
		byte buffer[] = null ;

		buffer = new byte[1];

		try{
		while( file.read( buffer ) >=  0 )
			tmp.append( new String( buffer ) );
		} catch( IOException e ){
			e.printStackTrace();
		}

		input = tmp.toString();
	}

	String getNext(){
	/* cut document input into components */

		if( index >= input.length() ) return null;

		StringBuffer result = new StringBuffer();

		if( input.charAt(index) == '<' ) {

			//System.out.println("::tag");

			while( input.charAt(index) != '>' ){
				result.append( input.substring(index,index+1) );
				index ++;
				if( index >= input.length() ) break;
			}
			result.append( input.substring(index,index+1) );
			index ++;
		}
		else{
			//System.out.println("::text");
			while( input.charAt(index) != '<' ){
				result.append( input.substring(index,index+1) );
				index ++;
				if( index >= input.length() ) break;
			}
		}
		return result.toString();
	}

	void reset(){ index = 0 ;}
}
