import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class ListQuality extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out = response.getWriter();

			if(CookieUser.getUser(request)==null)
				response.sendRedirect(JoeEnv.LoginLocation);

			String qgameid=request.getParameter("gameid");

			String gameidQuery="";

			if(qgameid!=null&&qgameid.length()!=0)
				gameidQuery=" AND joe_quality.gameid="+qgameid;

			String queryString="SELECT joe_quality.gameid, joe_game.name, joe_quality.graphic, joe_quality.sound, joe_quality.scenario FROM joe_game, joe_quality WHERE joe_quality.gameid = joe_game.gameid"+gameidQuery;

			out.println("<!--");
			out.println(queryString);
			out.println("-->");

			out.println("<HTML>");
			out.println("<HEAD>");
			out.println("<TITLE>");
			out.println("Quality");
			out.println("</TITLE>");
			out.println("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\""+JoeEnv.styleDir+"/labstyle.css\" TITLE=\"Style\"");
			out.println("</HEAD>");
			out.println("<BODY bgcolor=\"#ffffff\">");
			out.println("<CENTER><A HREF=\"ListQuality\"><IMG SRC=\"");
			out.println(JoeEnv.imgDir+"/project/banner_quality.gif\" border=0></A>");
			out.println("<P>");
			out.println("<TABLE BORDER=5>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Game Name");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Graphic");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Sound");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Scenario");
			out.println("</TH>");

			if(JoeEnv.admin.equals(CookieUser.getUser(request)))
			{
				out.println("<TH NOWRAP ALIGN=RIGHT>");
				out.println("</TH>");
				out.println("<TH NOWRAP ALIGN=RIGHT>");
				out.println("</TH>");
			}

			out.println("</TR>");

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				String gameid=(String)resultEntryVector.elementAt(0);
				String gamename=(String)resultEntryVector.elementAt(1);
				String graphic=(String)resultEntryVector.elementAt(2);
				String sound=(String)resultEntryVector.elementAt(3);
				String scenario=(String)resultEntryVector.elementAt(4);

				out.println("<TR>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?gameid="+gameid);
				out.println("\">");
				out.println(gamename);
				out.println("</TD>");

				if(JoeEnv.admin.equals(CookieUser.getUser(request)))
				{
					int a;

					out.println("<FORM METHOD=\"POST\" ACTION=\"UpdateQuality\">");
					out.println("<INPUT TYPE=\"HIDDEN\"");
					out.println("NAME=\"gameid\"");
					out.println("VALUE=\""+gameid+"\"");
					out.println(">");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					a=Integer.parseInt(graphic);
					out.println("<SELECT NAME=\"graphic\">");
					for(int i=0;i<=5;i++)
					{
						if(i==a)
							out.println("<OPTION VALUE="+i+" SELECTED>"+i);
						else
							out.println("<OPTION VALUE="+i+">"+i);
					}
					out.println("</SELECT>");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					a=Integer.parseInt(sound);
					out.println("<SELECT NAME=\"sound\">");
					for(int i=0;i<=5;i++)
					{
						if(i==a)
							out.println("<OPTION VALUE="+i+" SELECTED>"+i);
						else
							out.println("<OPTION VALUE="+i+">"+i);
					}
					out.println("</SELECT>");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					a=Integer.parseInt(scenario);
					out.println("<SELECT NAME=\"scenario\">");
					for(int i=0;i<=5;i++)
					{
						if(i==a)
							out.println("<OPTION VALUE="+i+" SELECTED>"+i);
						else
							out.println("<OPTION VALUE="+i+">"+i);
					}
					out.println("</SELECT>");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"update\">");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<INPUT TYPE=\"RESET\" VALUE=\"reset\">");

					out.println("</TD>");

					out.println("</FORM>");
				}
				else
				{
					out.println("<TD NOWRAP ALIGN=RIGHT>");
					for(int i=0;i<Integer.parseInt(graphic);i++)
					{
						out.println("<IMG SRC=\"");
						out.println(JoeEnv.imgDir+"/score.gif");
						out.println("\">");
					}
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					for(int i=0;i<Integer.parseInt(sound);i++)
					{
						out.println("<IMG SRC=\"");
						out.println(JoeEnv.imgDir+"/score.gif");
						out.println("\">");
					}
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					for(int i=0;i<Integer.parseInt(scenario);i++)
					{
						out.println("<IMG SRC=\"");
						out.println(JoeEnv.imgDir+"/score.gif");
						out.println("\">");
					}
					out.println("</TD>");
				}

				out.println("</TR>");
			}

			out.println("</CENTER></TABLE>");
			out.println("</BODY>");
			out.println("</HTML>");
			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
