import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;


public class Kif extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out=response.getWriter();

			String kifinput=request.getParameter("kifinput").trim();

			SelectToken p;
			p = new SelectToken() ;
			p.selectToken("null", kifinput, true);

//			out.println("<!--");
//			out.println(kifinput);
//			out.println("-->");

			String priceob="";

			if(!p.data.Less.equals("")&&p.data.More.equals(""))
				priceob="%3C";
			else if(p.data.Less.equals("")&&!p.data.More.equals(""))
				priceob="%3E";
			else
				priceob="%3D";

			response.sendRedirect("ListGame?name="+p.data.Name+"&price="+p.data.Price+"&priceob="+priceob+"&company="+p.data.Company+"&year="+p.data.Birth);

			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
