import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class ListSupplier extends HttpServlet
{
	DBQuery dbQuery;

	public void init(ServletConfig config) throws ServletException
	{
		super.init(config);
		dbQuery=new DBQuery();
	}

	public void destroy()
	{
		dbQuery.close();
		dbQuery=null;
	}

	public void doGet(HttpServletRequest request,HttpServletResponse response) 
	{
        	try
		{
			PrintWriter out;
			response.setContentType("text/html");

			out=response.getWriter();

			if(!JoeEnv.admin.equals(CookieUser.getUser(request)))
				response.sendRedirect(JoeEnv.menuLocation);

			String qsupplyname=request.getParameter("supplyname");
			String qsupplyid=request.getParameter("supplyid");

			String supplynameQuery="";
			String supplyidQuery="";
			String gamenameQuery="";
			String gameidQuery="";

			if(qsupplyname!=null&&qsupplyname.length()!=0)
				supplynameQuery=" AND joe_supplier.name LIKE '%"+qsupplyname+"%'";
			if(qsupplyid!=null&&qsupplyid.length()!=0)
				supplyidQuery=" AND joe_supplier.supplyid="+qsupplyid;
			String queryString="SELECT supplyid, name, place, website, manager, email, TO_CHAR(birthdate, 'YYYY/MM/DD') FROM joe_supplier WHERE joe_supplier.supplyid = joe_supplier.supplyid"+supplynameQuery+supplyidQuery;

			out.println("<!--");
			out.println(queryString);
			out.println("-->");

			out.println("<HTML>");
			out.println("<HEAD>");
			out.println("<TITLE>");
			out.println("Supplier");
			out.println("</TITLE>");
			out.println("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\""+JoeEnv.styleDir+"/labstyle.css\" TITLE=\"Style\"");
			out.println("</HEAD>");
			out.println("<BODY bgcolor=\"#ffffff\">");
			out.println("<CENTER><A HREF=\"ListSupplier\"><IMG SRC=\"");
			out.println(JoeEnv.imgDir+"/project/banner_supplier.gif\" border=0></A></CENTER>");
			out.println("<P>");
	
			out.println("<TABLE BORDER=5>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Supplier Name");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Place");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Homepage");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Manager");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Email");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("Birth Date");
			out.println("</TH>");

			out.println("<TH NOWRAP ALIGN=RIGHT>");
			out.println("List Game");
			out.println("</TH>");

			if(JoeEnv.admin.equals(CookieUser.getUser(request)))
			{
				out.println("<TH NOWRAP ALIGN=RIGHT>");
				out.println("Update");
				out.println("</TH>");

				out.println("<TH NOWRAP ALIGN=RIGHT>");
				out.println("Delete");
				out.println("</TH>");
			}

			out.println("</TR>");

			Vector result=dbQuery.query(queryString);
			Iterator resultIterator=result.iterator();
			Vector resultEntryVector;
			while(resultIterator.hasNext())
			{
				resultEntryVector=(Vector)resultIterator.next();

				String supplyid=(String)resultEntryVector.elementAt(0);
				String name=(String)resultEntryVector.elementAt(1);
				String place=(String)resultEntryVector.elementAt(2);
				String website=(String)resultEntryVector.elementAt(3);
				String manager=(String)resultEntryVector.elementAt(4);
				String email=(String)resultEntryVector.elementAt(5);
				String birthdate=(String)resultEntryVector.elementAt(6);

				out.println("<TR>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListSupplier?supplyid="+supplyid);
				out.println("\">");
				out.println(name);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println(place);
				out.println("</TD>");
				
				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println(website);
				out.println("\">");
				out.println(website);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("mailto:"+email);
				out.println("\">");
				out.println(manager);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("mailto:"+email);
				out.println("\">");
				out.println(email);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println(birthdate);
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<A HREF=\"");
				out.println("ListGame?supplyid="+supplyid);
				out.println("\">");
				out.println("List Game");
				out.println("</TD>");

				if(JoeEnv.admin.equals(CookieUser.getUser(request)))
				{
					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<A HREF=\"");
					out.println("UpdateSupplier?supplyid="+supplyid);
					out.println("\">");
					out.println("Update Supplier");
					out.println("</TD>");

					out.println("<TD NOWRAP ALIGN=RIGHT>");
					out.println("<A HREF=\"");
					out.println("DeleteSupplier?supplyid="+supplyid);
					out.println("\">");
					out.println("Delete Supplier");
					out.println("</TD>");
				}

				out.println("</TR>");
			}
			
			if(JoeEnv.admin.equals(CookieUser.getUser(request)))
			{
				out.println("<TR>");
				out.println("<FORM METHOD=\"POST\" ACTION=\"InsertSupplier\">");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"supplyname\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"place\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"website\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"manager\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"email\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"birthdatey\" SIZE=\"4\">");
				out.println("/");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"birthdatem\" SIZE=\"2\">");
				out.println("/");
				out.println("<INPUT TYPE=\"TEXT\" NAME=\"birthdated\" SIZE=\"2\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"SUBMIT\" VALUE=\"insert\">");
				out.println("</TD>");

				out.println("<TD NOWRAP ALIGN=RIGHT>");
				out.println("<INPUT TYPE=\"RESET\" VALUE=\"reset\">");
				out.println("</TD>");

				out.println("</FORM>");

				out.println("</TR>");
			}

			out.println("</TABLE>");
			out.println("</BODY>");
			out.println("</HTML>");
			out.close();
		}
		catch(Exception e)
		{
		}
        }

	public void doPost(HttpServletRequest request,HttpServletResponse response) 
	{
		doGet(request,response);
	}
}
