/*
	AI project 
*/

import java.io.*;
import jbf.*;
import jkp.*;
import java.util.*;
import java.lang.*;

public class SelectToken {
	private String buf, temp, temp1, temp2, top, nextop;
	private String text;
	private StringBuffer buffer, tag;	
	private StringTokenizer input, token, token1;
	private Stack Spar;
	public  Attributes data;
	private String value;
	public DBSelect db;
	
	SelectToken() {
		Spar = new Stack();
		data = new Attributes();
		buffer = new StringBuffer();
		tag = new StringBuffer();
	}
		
	private StringBuffer IntToBit(int value)
   {
	    	StringBuffer bits = new StringBuffer(7);

		for (int i=0; i<7; i++) {
			if ((value & 1) == 1)               // filtering the LSB
				bits.append('1');
			else
				bits.append('0');
			value = value >> 1;                 // shift right 1 bit
		}
		return bits;
	}

	
	public void selectToken(String file, String str, boolean b) {
		int ch = 0; 
		FileInputStream in;
		String first = null;
		boolean quoteFlag = false;
		int c;

		try {
			if(b == false) {
				in  = new FileInputStream(file);
				while ( ( c = in.read() ) > -1 )        
	                        buffer.append((char)c);
				text = buffer.toString();
			} else {
				text = str;
			}

			input = new StringTokenizer(text, "\t\n\r", false);
			token = new StringTokenizer(text, "( )\n", false);

			while ( input.hasMoreTokens() ) {

				temp1 = input.nextToken();
				KifObj obj = KifParser.parse(temp1);
				temp = obj.toString();
			}

			while ( token.hasMoreTokens() ) {
					
				temp2 = token.nextToken();	
				if ( temp2.indexOf("'") != -1 ) {
					if (quoteFlag == false) {
						quoteFlag = true;
						first = temp2;
						continue;
					}
					else {
						quoteFlag = false;
						int length = temp2.length();
						temp2 = first.substring(1) + " " + temp2.substring(0, length-1);
					}
				}

				Spar.push(temp2);
			} 

			while(true) {
				top = (String)Spar.pop();
				nextop = (String)Spar.pop();

				if ( top.compareTo("<") == 0  ) {	
					Spar.push(nextop);
					data.Less = "<";
					continue;
				}
				if ( top.compareTo(">") == 0  ) {	
					Spar.push(nextop);
					data.More = ">";
					continue;
				}
				if ( nextop.compareTo("Name") == 0  ) {	
					data.Name = top;
					ch = ch + (int)Math.pow( 2.0, 6.0 );
				}
				if ( nextop.compareTo("Price") == 0  ) {					
					data.Price = top;
					ch = ch + (int)Math.pow(2.0, 5.0);
				}
				if ( nextop.compareTo("Birth") == 0  ) {					
					data.Birth = top;
					ch = ch + (int)Math.pow( 2.0, 4.0 );
				}
				if ( nextop.compareTo("Company") == 0  ) {					
					data.Company = top;
					ch = ch + (int)Math.pow( 2.0, 3.0 );
				}
				if ( nextop.compareTo("Genre") == 0  ) {					
					data.Genre = top;
					ch = ch + (int)Math.pow( 2.0, 2.0 );
				}
				data.Print();
			}
		}
		
		catch (EmptyStackException e) { 
			tag = IntToBit(ch);
			tag.reverse();
			data.Tag = tag.toString();
		}

		catch (IOException e) { 
			System.out.println("IOException : " + e);
			System.out.println("PE\n");
		}

		catch (ParseException e) { 
			String test = ("ParseException : " + e);
			System.out.println("ParseException : " + e);
			System.out.println("PE\n");
		}

		catch (ArithmeticException e) { 
			System.out.println("ArithmeticException : " + e);
			System.out.println("PE\n");
		}
	}
}

