DROP TABLE joec_url;
DROP TABLE joec_user;
DROP TABLE joec_game;
DROP SEQUENCE joec_game_id;

CREATE SEQUENCE joec_game_id
INCREMENT BY 1
START WITH 1
MAXVALUE 999999999999
NOCACHE
NOCYCLE
;

CREATE TABLE joec_game
(
id NUMBER(12) NOT NULL,
name CHAR(50) NOT NULL,
genre CHAR(50),
birth DATE,
price NUMBER(10,2),
site CHAR(255),
company CHAR(255),
PRIMARY KEY (id)
)
;

CREATE TABLE joec_user
(
id CHAR(10),
password CHAR(10),
name CHAR(50),
age CHAR(10),
job CHAR(10),
hobby CHAR(10),
character CHAR(10),
email CHAR(255),
cpu CHAR(20),
ram CHAR(10),
hdd CHAR(10),
PRIMARY KEY (id)
)
;

CREATE TABLE joec_url
(
site CHAR(255),
hit NUMBER(2),
PRIMARY KEY (site)
)
;
